import java.awt.Color;

/*Ghassan Fakher
 * section 6
 * 201301739
 * gkf01*/
public class TicTacToe {
	public static void main(String[] args)
	{
		int[] cells = new int[9];
		double random = Math.random();
		if(random >= 0.5)
		{
			while(!checkWin(cells, 1) && !checkWin(cells, 0))
	
			{
				userTurn(cells);
				drawGrid(cells);
				if(checkWin(cells, 0))
				{
					StdOut.println("Congratulations. You Win!");
					break;
				}
				
				computerTurn(cells);
				drawGrid(cells);
				if(checkWin(cells, 1))
				{
					StdOut.println("Computer Wins!");
					break;
				} 
			}
		}	
		else { // computer starts first
			while(!checkWin(cells, 1) && !checkWin(cells, 0)) 
			{
				computerTurn(cells);
				drawGrid(cells);
				if(checkWin(cells, 1))
				{
					StdOut.println("Computer Wins!");
					break;
				}

				userTurn(cells);
				drawGrid(cells);
				if(checkWin(cells, 0))
				{
					StdOut.println("Congratulations. You Win!");
					break;
				}
			}
		}// end of else statement
	}// end of startGame method	
	

	public static boolean userTurn(int[] cells)
	{
		int id = 0;
		StdOut.print("Enter a cell: ");
		int userChoice = StdIn.readInt();
		if(cells[userChoice] == 0)
			cells[userChoice] = 1;
		else
		{
			while(cells[userChoice] != 0)
			{
				StdOut.println("Already selected\nEnter a cell:");
				userChoice = StdIn.readInt();
			}
			cells[userChoice] = 1;
		}
		drawGrid(cells);
		return checkWin(cells, id);
	}

	public static boolean computerTurn(int[] cells)
	{
		int id = 1;
		int random = (int)(Math.random() * 8) + 1;
		while(cells[random] != 0)
			random = (int)(Math.random() * 8) + 1;
		cells[random] = 2;
		StdOut.println("The computer chooses " + random);
		drawGrid(cells);
		return checkWin(cells, id);	//checks whether the computer wins
	}
	public static boolean checkWin(int[] cells, int id)
	{
		boolean userWins=false;
		boolean computerWins=false;
		if (id==0){
			if(cells[0]==1 && cells[1]==1 &&cells[2]==1)
			{
				userWins=true;
			} else if(cells[3]==1 && cells[4]==1 &&cells[5]==1)
			{
				userWins=true;
			} else if(cells[6]==1 && cells[7]==1 &&cells[8]==1)
			{
				userWins=true;
			} else if(cells[0]==1 && cells[3]==1 &&cells[6]==1)
			{
				userWins=true;
			}else if(cells[1]==1 && cells[4]==1 && cells[7]==1)
			{
				userWins=true;
			}else if(cells[2]==1 && cells[5]==1 &&cells[8]==1)
			{
				userWins=true;
			} else if(cells[0]==1 && cells[4]==1 && cells[8]==1)
			{
				userWins=true;
			}else if(cells[2]==1 && cells[4]==1 && cells[6]==1)
			{
				userWins=true;
			}
		}else if(id==1)
		{
			if(cells[0]==2 && cells[1]==2 &&cells[2]==2)
			{
				computerWins=true;
			} else if(cells[3]==2 && cells[4]==2 &&cells[5]==2)
			{
				computerWins=true;
			} else if(cells[6]==2 && cells[7]==2 &&cells[8]==2)
			{
				computerWins=true;
			} else if(cells[0]==2 && cells[3]==2 &&cells[6]==2)
			{
				computerWins=true;
			}else if(cells[1]==2 && cells[4]==2 && cells[7]==2)
			{
				computerWins=true;
			}else if(cells[2]==2 && cells[5]==2 &&cells[8]==2)
			{
				computerWins=true;
			} else if(cells[0]==2 && cells[4]==2 && cells[8]==2)
			{
				computerWins=true;
			}else if(cells[2]==2 && cells[4]==2 && cells[6]==2)
			{
				computerWins=true;
			}
		}

		if(id==1)
			return computerWins;
		else
			return userWins;

	}
	
	public static void drawGrid(int[] cells)
	{
		StdDraw.setXscale(0, 300);
		StdDraw.setYscale(0, 300);
		StdDraw.setPenColor(Color.black);
		StdDraw.square(150., 150., Math.sqrt(180000) / 2);
		for(int row = 50 ; row <= 250 ; row += 100)
		{
			for(int column = 50; column <= 250; column+= 100)
			{
				StdDraw.square(row * 1.0, column * 1.0 , Math.sqrt(10000) / 2.0);	
			}
		}
		for(int y = 50 ; y <= 250 ; y += 100)
		{
			for(int x = 50; x <= 250; x+= 100)
			{
				for(int i = 0; i < cells.length; i++)
				{
					if(i == 0) 
					{x = 50; y = 50;}
					else if(i == 1) 
					{x = 150; y = 50;}
					else if(i == 2) 
					{x = 250; y = 50;}
					else if(i == 3) 
					{x = 50; y = 150;}
					else if(i == 4) 
					{x = 150; y = 150;}
					else if(i == 5) 
					{x = 250; y = 150;}
					else if(i == 6) 
					{x = 50 ; y = 250;}
					else if(i == 7) 
					{x = 150 ; y = 250;}
					else if(i == 8) 
					{x = 250 ; y = 250;}

					if(cells[i] == 1)
					{
						StdDraw.line(x - 50, y - 50, x + 50, y + 50);
						StdDraw.line(x - 50, y + 50, x + 50, y - 50);
					}
					else if(cells[i] == 2)
					{
						StdDraw.filledCircle(x, y, 40.);
					}
				}
			}
		}	
	}
}
