import java.awt.Color;

/*Ghassan Fakher
 * section 6
 * gkf01
 * 201301739*/

public class GrayImage {
	public static void main(String[] args)
	{
		Picture original = new Picture("monkey.jpg");	//we don't want to change the original picture, so we make a copy of it
		Picture pic = new Picture(original);
		int width = pic.width();
		int height = pic.height(); 
		for(int row = 1; row < height; row++)
		{
			for(int column = 1; column < width; column++)
			{
				Color pixel = pic.get(row, column);
				int r = pixel.getRed();
				int g = pixel.getGreen();
				int b = pixel.getBlue();
				int average = (int)((r + b + g) / 3);
				Color shadeGray = new Color (average, average, average);	//a gray color has same arguments; it is on the interior diagonal of the RBG cube..
				pic.set(row, column, shadeGray);
				pic.show();
			}
		}
	}
}
